<?php

namespace App\Console\Commands;

use Cache;
use Carbon\Carbon;
use Illuminate\Console\Command;
use Illuminate\Http\Request as Http;
use Unirest\Request;

class VerifyLicenseKey extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'verify:license:key';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Verify license key';

    /**
     * Execute the console command.
     *
     * @param Http $http
     * @return mixed
     * @throws \Exception
     */
    public function handle(Http $http)
    {
        $licensing_secret_key = 'weX15Z7WEEXEJUDFXe101stateblah1273c8ggbZnut';

        if (env('LICENSE_KEY', '') === '') {
            $response = Request::post('http://license.monitorit.ru/api/v1/trial', [], [
                'name'        => 'База машин',
                'domain'      => $http->url(),
                'ip'          => $http->ip()
            ]);

            if ($response->code !== 200) {
                throw new \Exception('Ошибка получения триального ключа');
            }

            if ($response->body->status !== 'Active') {
                throw new \Exception($response->body->status);
            }

            $envFile = base_path('.env');

            if (file_exists($envFile)) {
                file_put_contents($envFile, str_replace('LICENSE_KEY=', 'LICENSE_KEY=' . $response->body->key, file_get_contents($envFile)));
            }

            return;
        }

        $response = Request::post('http://license.monitorit.ru/api/v1/verify', [], [
            'license_key' => env('LICENSE_KEY'),
            'domain'      => $http->url(),
            'ip'          => $http->ip()
        ]);

        if ($response->code !== 200) {
            throw new \Exception('Ошибка проверки лицензионного ключа');
        }

        if ($response->body->status === 'Expired') {
            throw new \Exception('Лицензионный ключ истек');
        }

        if ($response->body->status === 'Suspended') {
            throw new \Exception('Лицензионный ключ заблокирован');
        }

        if ($response->body->status !== 'Active') {
            throw new \Exception($response->body->status);
        }

        $dataEncoded = serialize($response->body);
        $dataEncoded = base64_encode($dataEncoded);
        $dataEncoded = md5(date('Ymd') . $licensing_secret_key) . $dataEncoded;
        $dataEncoded = strrev($dataEncoded);
        $dataEncoded .= md5($dataEncoded . $licensing_secret_key);
        $dataEncoded = wordwrap($dataEncoded, 80, "\n", true);

        Cache::put('LICENSE_LOCAL_KEY', $dataEncoded, Carbon::now()->addDays(3));
    }
}
