<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateClientsFieldsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('clients_fields', function(Blueprint $table) {
            $table->increments('id');
            $table->enum('clients_type', ['individual', 'entity'])->default('individual');
            $table->string('name', 255);
            $table->string('type', 10);
            $table->text('options')->nullable();
            $table->text('description')->nullable();
            $table->integer('required')->default('0');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::drop('clients_fields');
    }
}
